/* L-Dic(Linux Dictionary)
 * Copyright (C) 2002 Baek SeungSoon.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */
#include <stdio.h>
#include <string.h>

/* MakeList:   о  
 */
extern int
MakeList(const char *dicName, const char *listName)
{
	int pos = 0;
	int mean = 0;
	char remember[BUFSIZ+1];
	
	FILE *dbfp;
	FILE *listfp;
	
	dbfp = fopen(dicName, "r");
	if (dbfp == NULL) {
		return 1;
	}

	listfp = fopen(listName, "w");
	if (listfp == NULL) {
		return 1;
	}

	bzero(&remember, sizeof(remember));
	while (!feof(dbfp)) {
		char ch;
		
		ch = fgetc(dbfp);

		if (ch != '\0' && mean == 0) {
			remember[pos] = ch;
			pos++;
		} else if (ch == '\0') {
			if (mean == 0) {
				char buf[BUFSIZ+1];
				
				remember[pos] = '\0';
				
				sprintf(buf, "%ld,%s\n", ftell(dbfp), remember);
				fputs(buf, listfp);
				
				pos = 0;
				mean = 1;
			} else
				mean = 0;
		}
	}

	fclose(listfp);
	fclose(dbfp);

	return 0;
}
