/* L-Dic(Linux Dictionary)
 * Copyright (C) 2002 Baek SeungSoon.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */
#include <stdio.h>
#include <string.h>

/* getXpmArray: XPM  о, ͷ ȯ
 */
static char
**getXpmArray(const char *xpmfile)
{
	int i;
	int ch;
	char *s;
	FILE *fp;
	char buf[BUFSIZ+1];

	int pos = 0;
	static char *xpm[BUFSIZ+1];
	
	struct xpm_t {
		int x;
		int y;
		int color;
		int temp;
	} xpm_t = { 0, 0, 0, 0 };
	
	fp = fopen(xpmfile, "r");
	if (fp == NULL) {
		return NULL; /*  б  */
	}

	for (ch = fgetc(fp); ch != '\"'; ch = fgetc(fp))
		continue;

	fgets(buf, sizeof(buf), fp);
	s = strchr(buf, '\"');

	sscanf(buf, "%d %d %d %d",
			&xpm_t.x, &xpm_t.y,
			&xpm_t.color, &xpm_t.temp);

	for (i = 0; i <= xpm_t.color; i++)
		fgets(buf, sizeof(buf), fp);

	bzero(&buf, sizeof(buf));
	while (!feof(fp)) {
		fgets(buf, sizeof(buf), fp);
		
		s = strrchr(buf, '\"');
		if (s == NULL)
			continue;
		*s = '\0';

		xpm[pos] = strdup(buf+1);
		pos++;
	}
	xpm[pos] = NULL;
	
	fclose(fp);

	return xpm; /*  */
}

#define S_WIDTH		80
#define S_HEIGHT	80
/* DrawPhon:   dir xpm  text 
 */
extern int
PrintXpm(char **xpmlist, const char *dir)
{
	int i;

	int listc = 0;
	char *listv[BUFSIZ+1];

	int x, y;
	int x_pos = 0, y_pos = 0;
	char screen[S_HEIGHT][S_WIDTH];

	for (i = 0; xpmlist[i] != NULL; i++) {
		char *s;
		char *p;
		char buf[BUFSIZ+1];
#ifdef _DEBUG
		printf("xpmlist[%d]=> %s\n", i, xpmlist[i]);
#endif
		s = strchr(xpmlist[i], '.');
		if (s == NULL)
			break;
		p = strrchr(xpmlist[i], '.');
		if (p == NULL)
			break;
		*p = '\0';
		
		sprintf(buf, "%s/%s.xpm", dir, s+1);
		listv[listc] = strdup(buf);
		listc++;
	}

	bzero(&screen, sizeof(screen));
	for (i = 0; i < listc; i++) {
		char **xpm;
		
		xpm = getXpmArray(listv[i]);
		if (xpm == NULL)
			continue;
		
		if ((y_pos+(y-1)) >= S_HEIGHT)
			break;

		if (x_pos+x >= S_WIDTH) {
			y_pos += y-1;
			x_pos = 0;
		}
	
		for (y = 0; xpm[y] != NULL; y++) {
			for (x = 0; xpm[y][x] != '\0'; x++) {
				screen[y+y_pos][x+x_pos] = xpm[y][x];
			}
		}

		x_pos += x-1;
	}

	y_pos += y;
	for (y = 0; y < y_pos; y++) {
		for (x = 0; x < S_WIDTH; x++) {
			switch (screen[y][x]) {
				case '.':
					printf(".");
					break;
				default:
					printf(" ");
					break;
			}
		}
		printf("\n");
	}

	return 0;
}
