/* L-Dic(Linux Dictionary)
 * Copyright (C) 2002 Baek SeungSoon.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */
#include <stdio.h>
#include <string.h>

#include "wlist.h"

/* ListSearchWord: Ʈ ܾ ˻
 */
extern long
ListSearchWord(WList *listp, char *word)
{
	long offset;

	for ( ; listp != NULL; listp = listp->next) {
		if (strcmp(word, listp->word) == '\0') {
			offset = listp->offset;
			return offset;
		}
	}

	return -1; /* ã  */
}

/* FileSearchWord: ־ Ͽ ܾ ˻
 */
extern long
FileSearchWord(char *word, char *listName)
{
	FILE *fp;
	long offset;
	char buf[BUFSIZ+1];
	
	fp = fopen(listName, "r");
	if (fp == NULL) {
		return -1;
	}

	for (;;) {
		fscanf(fp, "%ld,%s", &offset, buf);
		if (feof(fp)) {
			fclose(fp);
			return -1;
		}
		
		if (strcmp(word, buf) == '\0') {
			break;
		}
	}
	fclose(fp);

	return offset;
}

/* dbSearchMean: ־  offset ˻Ͽ,
 *               '\0' ϰ ȯ
 */
extern char *
dbSearchMean(long offset, char *dicName)
{
	FILE *fp;

	int pos = 0;
	static char mean[100000];
	
	fp = fopen(dicName, "r");
	if (fp == NULL)
		return NULL;

	fseek(fp, offset, SEEK_SET);
	bzero(&mean, sizeof(mean));

	for (;;) {
		char ch;

		ch = fgetc(fp);
		if (feof(fp)) {
			fclose(fp);
			return NULL;
		}
		
		if (ch != '\0') {
			mean[pos] = ch;
			pos++;
		} else if (ch == '\0') {
			mean[pos] = '\0';
			pos = 0;
			break;
		}
	}

	fclose(fp);

	return mean; /* ڿ */
}
